autowatch = 1;

inlets = 1;
outlets =6;

setinletassist (0, "Mubu event (list: [index (int), duration (float), peak (float), pitch(float), pitch deveiation (float)])");

setoutletassist (0, "event index");
setoutletassist (1, "list of durations");
setoutletassist (2, "list of peaks");
setoutletassist (3, "list of pitches");
setoutletassist (4, "list of pitch deviations");
setoutletassist (5, "formatted messages to concat_control");

var durations, peaks, pitches, pitchdevs;
var thisIndex, thisDuration, thisPeak, thisPitch, thisPitchdev;

reset;

function list() {
	var a = arrayfromargs(messagename,arguments);
	
	thisIndex = a[0];
	thisDuration = a[1];
	thisPeak = a[2];
	thisPitch = a[3];
	thisPitchdev =a[4];
	
	durations.push(thisDuration);
	peaks.push(thisPeak);
	pitches.push(thisPitch);
	pitchdevs.push(thisPitchdev);
	
	bang();
	
}

function bang(){
	
	outlet(5, formatData("all", "pitchdevs",range(pitchdevs)));
	outlet(5, formatData("all", "pitches",range(pitches)));
	outlet(5, formatData("all", "peaks",range(peaks)));
	outlet(5, formatData("all", "durations",range(durations)));
	
/*	outlet(5, formatData("all", "pitchdevs",pitchdevs));
	outlet(5, formatData("all", "pitches",pitches));
	outlet(5, formatData("all", "peaks",peaks));
	outlet(5, formatData("all", "durations",durations));
*/	
	outlet(5, formatData("all", "pitchdevs",thisPitchdev));
	outlet(5, formatData("all", "pitches",thisPitch));
	outlet(5, formatData("all", "peaks",thisPeak));
	outlet(5, formatData("all", "durations",thisDuration));
	
	outlet(4, pitchdevs);
	outlet(3, pitches);
	outlet(2, peaks);
	outlet(1, durations);
	outlet(0, thisIndex);
}
	
	
	
function reset(){
	
	durations =[];
	peaks = [];
	pitches =[];
	pitchdevs = [];
}

function getMin(a){
	
	for(i=0, minimum = Number.MAX_VALUE, len = a.length; i<len; i++) {
		if(a[i]<minimum){minimum = a[i]};
			};
	
	return minimum;
	
}

function getMax(a){
	
	for(i=0, maximum =Number.MIN_VALUE, len = a.length; i<len; i++) {
		if(a[i]>maximum){maximum = a[i]};
			};
	
	return maximum;
	
}

function range(a){
	return ["range",(0.000001 + getMin(a)), getMax(a)];
}

function prepend(label, a){
	
	var b = [];
	b[0] =label;
	
	return b.concat(a);
}

function formatData(channel, label, data){

	return  prepend(channel, prepend(label, data));

}