autowatch =1;

inlets = 2;
outlets =2;

setinletassist(0, "current event index (int)");
setinletassist(1, "LIMIT toggle state (0/1)");
setoutletassist(1, "active events (list: 0s/1s)");
setoutletassist(2, "to button");

var statelist = [];
var limitToggle = 0;
var index = 0;

function msg_int(n) {
	
	switch(this.inlet) {
		case 0:
			index = n;
			statelist = append(statelist, !limitToggle);
			outlet (0, formatData("all", "eventStates", statelist));
			break;
		case 1:
			limitToggle = n;
			if (limitToggle == 0){
				statelist = array_fill(index+1, 1);
				};
			break;
		};
	};
		
function array_fill(len, val){
	var a = new Array(len);
	for (i = 0; i<len; i++) {
		a[i] = val;
	};
	return a;
};

function prepend(label, a){
	
	var b = [];
	b[0] =label;
	
	return b.concat(a);
};

function formatData(channel, label, data){

	return  prepend(channel, prepend(label, data));

};

function reset() {		
	statelist = [];
	limitToggle = 0;
	index = 0;
	outlet(1, ["set", limitToggle]);
};

function append(a, n){
	a.push(n);
	return a;
};

function bordercolor(red, green, blue, alpha) {
	outlet(1, ["bordercolor", red, green, blue, alpha]);
	outlet(1, ["borderoncolor", red, green, blue, alpha]);
};

	
function toggleoffcolor(red, green, blue, alpha) {
	outlet(1, ["bgcolor", red, green, blue, alpha]);
	outlet(1, ["bgovercolor", red, green, blue, alpha]);
};

function toggleoncolor(red, green, blue, alpha) {
	outlet(1, ["bgoncolor", red, green, blue, alpha]);
	outlet(1, ["bgoveroncolor", red, green, blue, alpha]);
};
		
		
		
		
		
		
